

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.analyze package &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="index.html"/> 

  
  <script src="_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="index.html">Docs</a> &raquo;</li>
      
    <li>d2o.analyze package</li>
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="_sources/d2o.analyze.txt" rel="nofollow"> View page source</a>
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="d2o-analyze-package">
<h1>d2o.analyze package<a class="headerlink" href="#d2o-analyze-package" title="Permalink to this headline">¶</a></h1>
<div class="section" id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-d2o.analyze.changedetection">
<span id="d2o-analyze-changedetection-module"></span><h2>d2o.analyze.changedetection module<a class="headerlink" href="#module-d2o.analyze.changedetection" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.analyze.changedetection.Period">
<em class="property">class </em><code class="descclassname">d2o.analyze.changedetection.</code><code class="descname">Period</code><span class="sig-paren">(</span><em>x0</em>, <em>x1</em>, <em>df=[]</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period" title="Permalink to this definition">¶</a></dt>
<dd><p>Period/Season definition.
Contains the start, end and length of the period.
A copy of the underlying dataframe is added in order to perform
per-period calculations.</p>
<dl class="method">
<dt id="d2o.analyze.changedetection.Period.add_vspan">
<code class="descname">add_vspan</code><span class="sig-paren">(</span><em>pltobj</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.add_vspan"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.add_vspan" title="Permalink to this definition">¶</a></dt>
<dd><p>Add a matplotlib vspan (graphical glyph).
Used for storing color and handles color conversion.
:param pltobj: matplotlib plot object (plt)
:returns:       Matplotlib vspan</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.length">
<code class="descname">length</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.length"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.length" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate season length:
:returns:       Season length</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.middle">
<code class="descname">middle</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.middle"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.middle" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate season center point:
:returns:       Season center point</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.rgb_string">
<code class="descname">rgb_string</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.rgb_string"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.rgb_string" title="Permalink to this definition">¶</a></dt>
<dd><p>String representation of the period RGB color
:returns:       String &#8216;r,g,b&#8217;</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.update">
<code class="descname">update</code><span class="sig-paren">(</span><em>cols</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.update"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.update" title="Permalink to this definition">¶</a></dt>
<dd><p>Update period signature
:param cols: The columns to be used for signature definition
:returns:       None</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.update_color">
<code class="descname">update_color</code><span class="sig-paren">(</span><em>color_cols=[None, None, None], color_map=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.update_color"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.update_color" title="Permalink to this definition">¶</a></dt>
<dd><p>Period color
:param color_cols: The columns in the underlying dataframe wich corresponds to [RGB] or [HSV].
:param color_map: deprecated, loaded from config. Contains hex vals for coloring.
:returns:       None</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.Period.update_pos">
<code class="descname">update_pos</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#Period.update_pos"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.Period.update_pos" title="Permalink to this definition">¶</a></dt>
<dd><p>Update period position
:param x: tuple or list [start,end]
:returns:       None</p>
</dd></dl>

</dd></dl>

<dl class="class">
<dt id="d2o.analyze.changedetection.ZScoreDetector">
<em class="property">class </em><code class="descclassname">d2o.analyze.changedetection.</code><code class="descname">ZScoreDetector</code><span class="sig-paren">(</span><em>df</em>, <em>color_cols=[]</em>, <em>color_map=None</em>, <em>circular=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector" title="Permalink to this definition">¶</a></dt>
<dd><p>Detects changepoints and calculates similar changing periods in a timeseries.
TODO: Tailored for d2o, needs to be generalized</p>
<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.add_padding">
<code class="descname">add_padding</code><span class="sig-paren">(</span><em>window</em>, <em>padding_size</em>, <em>min_size</em>, <em>max_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.add_padding"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.add_padding" title="Permalink to this definition">¶</a></dt>
<dd><p>Adds padding to the window.
Padding is clamped to [min_size, max_size]</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>window</strong> &#8211; Current window</li>
<li><strong>padding_size</strong> &#8211; size of padding (number of datapoints)</li>
<li><strong>min_size</strong> &#8211; clamp to this if smaller</li>
<li><strong>max_size</strong> &#8211; clamp to this if larger</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">A new window with padding addded</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.calculate_change_windows">
<code class="descname">calculate_change_windows</code><span class="sig-paren">(</span><em>z_scores</em>, <em>owindow_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.calculate_change_windows"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.calculate_change_windows" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate the position of the change windows based on
z-scores.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>z_scores</strong> &#8211; List of z_scores</li>
<li><strong>owindow_size</strong> &#8211; Size of outer window</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">A list of windows</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.calculate_changepoints">
<code class="descname">calculate_changepoints</code><span class="sig-paren">(</span><em>windows</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.calculate_changepoints"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.calculate_changepoints" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate changepoints per window.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>windows</strong> &#8211; list of windows</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">Changepoints</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.calculate_zscores">
<code class="descname">calculate_zscores</code><span class="sig-paren">(</span><em>iwindow_size</em>, <em>owindow_size</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.calculate_zscores"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.calculate_zscores" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates z-scores by running an inner and outer window over
the underlying timeseries (y)
:param iwindow_size: inner window size
:param owindow_size: outer window size
:returns:       List of z-scores (same length as y)</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.define_periods">
<code class="descname">define_periods</code><span class="sig-paren">(</span><em>changepoints</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.define_periods"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.define_periods" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculate periods/seasons based on changepoints.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>changepoints</strong> &#8211; List of changepoints</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">List of Period objects</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.finalize">
<code class="descname">finalize</code><span class="sig-paren">(</span><em>operiods</em>, <em>periods</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.finalize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.finalize" title="Permalink to this definition">¶</a></dt>
<dd><p>Finalization and cleanup.
TODO: Use a bigger sliding window with padding of real values to establish endpoints.
:param operiods: Original period definitions
:param periods: Cleaned period definitions
:returns:       tuple(operiods, periods)</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.merge_equal">
<code class="descname">merge_equal</code><span class="sig-paren">(</span><em>periods</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.merge_equal"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.merge_equal" title="Permalink to this definition">¶</a></dt>
<dd><p>Merge identical periods
:param periods: List of Periods (which may contain duplicates)
:returns:       List of Periods with duplicates removed</p>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.merge_similar">
<code class="descname">merge_similar</code><span class="sig-paren">(</span><em>periods</em>, <em>min_length</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.merge_similar"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.merge_similar" title="Permalink to this definition">¶</a></dt>
<dd><p>Recursively combine similar periods or periods smaller than min length into
larger periods.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>periods</strong> &#8211; List of Period objects</li>
<li><strong>min_length</strong> &#8211; minimum season length</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">List of Period objects</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="method">
<dt id="d2o.analyze.changedetection.ZScoreDetector.run">
<code class="descname">run</code><span class="sig-paren">(</span><em>ycol</em>, <em>iwindow_size</em>, <em>owindow_size</em>, <em>min_length</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#ZScoreDetector.run"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.ZScoreDetector.run" title="Permalink to this definition">¶</a></dt>
<dd><p>Run the season algorithm.
Selects the relevant timeseries (usually a PCA-reduced dataset).
Calculate diffs, zscores, changewindows, changepoints and determine the final seasons.
Then finally does some cleanup on the calculated periods.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><ul class="first simple">
<li><strong>ycol</strong> &#8211; The name of the column which contains the basis for the season calculation</li>
<li><strong>iwindow_size</strong> &#8211; inner window size</li>
<li><strong>owindow_size</strong> &#8211; outer window size</li>
<li><strong>min_length</strong> &#8211; minimum season length</li>
</ul>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last">Results, dictionary {</p>
</td>
</tr>
</tbody>
</table>
<p>&#8216;df&#8217;: # The underlying data (dataframe),
&#8216;color_cols&#8217;: Columns to be used for colorization,
&#8216;ycol&#8217;: Column which is the basis for the season calculation (e.g. PCA1)
&#8216;diffs&#8217;: Differences,
&#8216;z_scores&#8217;: Z-Scores,
&#8216;cws&#8217;: Change windows,
&#8216;cps&#8217;: Changepoints,
&#8216;operiods&#8217;: Original periods before cleanup,
&#8216;periods&#8217;: Actual periods / Seasons,
&#8216;iw_size&#8217;: Inner window size used in the calculation,
&#8216;ow_size&#8217;: Outer window size used in the calculation,
&#8216;min_length&#8217;: Minimum season length
}</p>
</dd></dl>

</dd></dl>

<dl class="function">
<dt id="d2o.analyze.changedetection.get_closest_in_range">
<code class="descclassname">d2o.analyze.changedetection.</code><code class="descname">get_closest_in_range</code><span class="sig-paren">(</span><em>val</em>, <em>rv=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/changedetection.html#get_closest_in_range"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.changedetection.get_closest_in_range" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the corresponding value in rn_ranges and
rv_ranges. Used to map the real value to a smaller range.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><strong>val</strong> &#8211; Value, revenue or room nights</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body">tuple(key of the closest value, closest value)</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-d2o.analyze.correlation">
<span id="d2o-analyze-correlation-module"></span><h2>d2o.analyze.correlation module<a class="headerlink" href="#module-d2o.analyze.correlation" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.analyze.correlation.CorrealtionTests">
<em class="property">class </em><code class="descclassname">d2o.analyze.correlation.</code><code class="descname">CorrealtionTests</code><span class="sig-paren">(</span><em>methodName='runTest'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#CorrealtionTests"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.CorrealtionTests" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">unittest.case.TestCase</span></code></p>
<dl class="method">
<dt id="d2o.analyze.correlation.CorrealtionTests.setUp">
<code class="descname">setUp</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#CorrealtionTests.setUp"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.CorrealtionTests.setUp" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation.CorrealtionTests.test_autocorrelation">
<code class="descname">test_autocorrelation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#CorrealtionTests.test_autocorrelation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.CorrealtionTests.test_autocorrelation" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation.CorrealtionTests.test_correlation_matrix">
<code class="descname">test_correlation_matrix</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#CorrealtionTests.test_correlation_matrix"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.CorrealtionTests.test_correlation_matrix" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation.CorrealtionTests.test_partial_autocorr">
<code class="descname">test_partial_autocorr</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#CorrealtionTests.test_partial_autocorr"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.CorrealtionTests.test_partial_autocorr" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation.autocorrelation">
<code class="descclassname">d2o.analyze.correlation.</code><code class="descname">autocorrelation</code><span class="sig-paren">(</span><em>df</em>, <em>confidence=95.0</em>, <em>nlags=None</em>, <em>keys='ALL'</em>, <em>detrend=False</em>, <em>plot=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#autocorrelation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.autocorrelation" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates autocorrelation for each column in df.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>confidence</strong> : float</p>
<blockquote>
<div><p>Default 95.</p>
</div></blockquote>
<p><strong>nlags :</strong></p>
<blockquote>
<div><p>Default None</p>
</div></blockquote>
<p><strong>keys</strong> : string or list</p>
<blockquote>
<div><p>Default &#8220;ALL&#8221;</p>
</div></blockquote>
<p><strong>detrend</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>plot</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>aco</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Columns contains aoutocorrelation of the columns in df with the
confidence interval represented as two lines.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation.correlation_matrix">
<code class="descclassname">d2o.analyze.correlation.</code><code class="descname">correlation_matrix</code><span class="sig-paren">(</span><em>df</em>, <em>method='pearson'</em>, <em>sort=True</em>, <em>abs_values=False</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#correlation_matrix"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.correlation_matrix" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates and returns the correlation matrix of the dataframe.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>method</strong> : str, default &#8216;pearson&#8217;</p>
<blockquote>
<div><p>vallid arguments: &#8216;pearson&#8217;, &#8216;kendall&#8217;, &#8216;spearman&#8217;.</p>
</div></blockquote>
<p><strong>sort</strong> : bool, default True</p>
<blockquote>
<div><p>not implemented, does nothing. Indexes will be sorted regardless of this argument.</p>
</div></blockquote>
<p><strong>plot</strong> : bool, default False</p>
<blockquote>
<div><p>Not implemented, function will not plot regardless of this argument.</p>
</div></blockquote>
<p><strong>abs_values</strong> : bool, default False</p>
<blockquote>
<div><p>If True, returns matrix with absolute values.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>corrmat</strong> : pd.DataFrame</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation.partial_autocorr">
<code class="descclassname">d2o.analyze.correlation.</code><code class="descname">partial_autocorr</code><span class="sig-paren">(</span><em>df</em>, <em>detrend=False</em>, <em>confidence=95.0</em>, <em>nlags=None</em>, <em>plot=False</em>, <em>keys='ALL'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation.html#partial_autocorr"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation.partial_autocorr" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates partial autocorrelation for each column.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>detrend</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>confidence</strong> : float</p>
<blockquote>
<div><p>Default 95.</p>
</div></blockquote>
<p><strong>nlags :</strong></p>
<blockquote>
<div><p>Default None</p>
</div></blockquote>
<p><strong>plot</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>keys</strong> : string or list</p>
<blockquote>
<div><p>keys to iterate over.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>paco</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe with the partial autocorrelation per column, and the upper and
lower bounds of the confidence interval as two lines.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-d2o.analyze.correlation_m">
<span id="d2o-analyze-correlation-m-module"></span><h2>d2o.analyze.correlation_m module<a class="headerlink" href="#module-d2o.analyze.correlation_m" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.analyze.correlation_m.CorrealtionTests">
<em class="property">class </em><code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">CorrealtionTests</code><span class="sig-paren">(</span><em>methodName='runTest'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#CorrealtionTests"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.CorrealtionTests" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">unittest.case.TestCase</span></code></p>
<dl class="method">
<dt id="d2o.analyze.correlation_m.CorrealtionTests.setUp">
<code class="descname">setUp</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#CorrealtionTests.setUp"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.CorrealtionTests.setUp" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation_m.CorrealtionTests.test_autocorrelation">
<code class="descname">test_autocorrelation</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#CorrealtionTests.test_autocorrelation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.CorrealtionTests.test_autocorrelation" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation_m.CorrealtionTests.test_correlation_matrix">
<code class="descname">test_correlation_matrix</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#CorrealtionTests.test_correlation_matrix"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.CorrealtionTests.test_correlation_matrix" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.analyze.correlation_m.CorrealtionTests.test_partial_autocorr">
<code class="descname">test_partial_autocorr</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#CorrealtionTests.test_partial_autocorr"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.CorrealtionTests.test_partial_autocorr" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.autocorrelation">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">autocorrelation</code><span class="sig-paren">(</span><em>df</em>, <em>confidence=95.0</em>, <em>nlags=None</em>, <em>keys='ALL'</em>, <em>detrend=False</em>, <em>plot=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#autocorrelation"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.autocorrelation" title="Permalink to this definition">¶</a></dt>
<dd><p>Does the autocorrelation on each column in the df.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>confidence</strong> : float</p>
<blockquote>
<div><p>Default 95.</p>
</div></blockquote>
<p><strong>nlags :</strong></p>
<blockquote>
<div><p>Default None</p>
</div></blockquote>
<p><strong>keys</strong> : string or list</p>
<blockquote>
<div><p>Default &#8220;ALL&#8221;</p>
</div></blockquote>
<p><strong>detrend</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>plot</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>aco</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Columns contain the aoutocorrelation of the columns in df and the
confidence interval.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.correlation_matrix">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">correlation_matrix</code><span class="sig-paren">(</span><em>df</em>, <em>method='pearson'</em>, <em>cluster=True</em>, <em>abs_values=False</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#correlation_matrix"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.correlation_matrix" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates and returnes the correlation matrix of the dataframe.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>method</strong> : str, default &#8216;pearson&#8217;</p>
<blockquote>
<div><p>vallid arguments: &#8216;pearson&#8217;, &#8216;kendall&#8217;, &#8216;spearman&#8217;.</p>
</div></blockquote>
<p><strong>cluster</strong> : bool, default True</p>
<blockquote>
<div><p>If True, the matrix will be clustered.</p>
</div></blockquote>
<p><strong>plot</strong> : bool, default False</p>
<blockquote>
<div><p>Not implemented, function will not plot regardless of this argument.</p>
</div></blockquote>
<p><strong>abs_values</strong> : bool, default False</p>
<blockquote>
<div><p>If True, returns matrix with absolute values.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first last"><strong>corrmat</strong> : pd.DataFrame</p>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.cross_corr_df">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">cross_corr_df</code><span class="sig-paren">(</span><em>df</em>, <em>keys='ALL'</em>, <em>mode='full'</em>, <em>n_last_elm=365</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#cross_corr_df"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.cross_corr_df" title="Permalink to this definition">¶</a></dt>
<dd><p>Cross-correlation of the columns in a data frame.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Data frame with the series to cross-correlate as columns.</p>
</div></blockquote>
<p><strong>keys</strong> : str or list, default &#8220;ALL&#8221;</p>
<blockquote>
<div><p>List of strings with the columns to cross-correlate.</p>
</div></blockquote>
<p><strong>mode</strong> : str, default &#8220;full&#8221;</p>
<blockquote>
<div><p>This argument is passed to np.correlate. Don&#8217;t change unless you know what you&#8217;re doing.</p>
</div></blockquote>
<p><strong>n_last_elm</strong> : int, default 365</p>
<blockquote>
<div><p>The number of elements to use when doing cross-correlation.
The default value works for timeseries with sampling frequency (Fs) of one day, or any other timeseries
with a periodicity of 365*Fs</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>ccf_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Data frame containing all the cross correlations of the columns.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><code class="xref py py-obj docutils literal"><span class="pre">numpy.correlate</span></code></dt>
<dd><a class="reference external" href="http://docs.scipy.org/doc/numpy-1.10.0/reference/generated/numpy.correlate.html">http://docs.scipy.org/doc/numpy-1.10.0/reference/generated/numpy.correlate.html</a></dd>
<dt><code class="xref py py-obj docutils literal"><span class="pre">wiki</span></code></dt>
<dd><a class="reference external" href="https://en.wikipedia.org/wiki/Cross-correlation">https://en.wikipedia.org/wiki/Cross-correlation</a></dd>
</dl>
</div>
<p class="rubric">Notes</p>
<p>A note on complexity: Due to the options available in numpy.correlate this function now does n**2 - n cross-correlations.
This is to maintain symetry in the data. The following last paragraph
is true for a optimized algorithm, but would require another library or a rewrite of the cross-correlation algorithm.</p>
<p>The number of cross-correlations done in this function is (1/2)/(n-1)n , where n is the number of columns.
If your dataframe has a lot of columns, the returned dataframe will be very large. E.g. 20 columns will produce
a cross_corr_table containing 190 columns. In general, the returned data frame will be (1/2)(n-1) times larger
than the input frame.</p>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.partial_autocorr">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">partial_autocorr</code><span class="sig-paren">(</span><em>df</em>, <em>detrend=False</em>, <em>confidence=95.0</em>, <em>nlags=None</em>, <em>plot=False</em>, <em>keys='ALL'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#partial_autocorr"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.partial_autocorr" title="Permalink to this definition">¶</a></dt>
<dd><p>Does the autocorrelation on each column in the df.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>detrend</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>confidence</strong> : float</p>
<blockquote>
<div><p>Default 95.</p>
</div></blockquote>
<p><strong>nlags :</strong></p>
<blockquote>
<div><p>Default None</p>
</div></blockquote>
<p><strong>plot</strong> : bool</p>
<blockquote>
<div><p>Default False</p>
</div></blockquote>
<p><strong>keys</strong> : string or list</p>
<blockquote>
<div><p>keys to itterate over.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>paco</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Columns contain the partial aoutocorrelation of the columns in df and the
confidence interval.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.transform_cross_df">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">transform_cross_df</code><span class="sig-paren">(</span><em>df</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#transform_cross_df"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.transform_cross_df" title="Permalink to this definition">¶</a></dt>
<dd><p>Transforms a cross_corr_df to conform to a four column data frame.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Data frame created in cross_corr_df() (remember to normalize input).</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>t_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe with columns, [h_id_source, segment_id_source, type_source, h_id_crrelated, segment_id_correlated,
type_correlated, lag, correlation]</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.transform_cross_df_d2o">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">transform_cross_df_d2o</code><span class="sig-paren">(</span><em>df</em>, <em>n_values='ALL'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#transform_cross_df_d2o"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.transform_cross_df_d2o" title="Permalink to this definition">¶</a></dt>
<dd><p>Transforms a cross_corr_df to conform to the d2o database table structure for
correlations.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Data frame created in cross_corr_df() (remember to normalize input).</p>
</div></blockquote>
<p><strong>n_values</strong> : int or str, default &#8220;ALL&#8221;</p>
<blockquote>
<div><p>Number of values to keep. If int, the table returned will only contain the n_values highest correlations
pr. cross_correlation.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>ret</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Dataframe with columns, [h_id_source, segment_id_source, type_source, h_id_crrelated, segment_id_correlated,
type_correlated, lag, correlation]</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="function">
<dt id="d2o.analyze.correlation_m.trim_cross_df">
<code class="descclassname">d2o.analyze.correlation_m.</code><code class="descname">trim_cross_df</code><span class="sig-paren">(</span><em>df</em>, <em>index_range</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/correlation_m.html#trim_cross_df"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.correlation_m.trim_cross_df" title="Permalink to this definition">¶</a></dt>
<dd><p>Trims the data frame and returns the elements in index_range.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<blockquote>
<div><p>Dataframe created using cross_corr_df()</p>
</div></blockquote>
<p><strong>index_range</strong> : int or list. List not implemented.</p>
<blockquote>
<div><p>If int, the function returns the index_range centered elements in df. If list, on the form [A, B], it will
return the indexes from A to B, including B.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>trimmed_df</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Trimmed data frame.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-d2o.analyze.fourier">
<span id="d2o-analyze-fourier-module"></span><h2>d2o.analyze.fourier module<a class="headerlink" href="#module-d2o.analyze.fourier" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.analyze.fourier.fftdf">
<code class="descclassname">d2o.analyze.fourier.</code><code class="descname">fftdf</code><span class="sig-paren">(</span><em>dataFrame</em>, <em>keys='ALL'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/analyze/fourier.html#fftdf"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.analyze.fourier.fftdf" title="Permalink to this definition">¶</a></dt>
<dd><p>Does a fast fourier transform on the columns in a dataframe. All columns
need to contain floats except index column.</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>dataFrame</strong> : pd.DataFrame</p>
<p><strong>keys</strong> : string or list, default &#8220;ALL&#8221;.</p>
<blockquote>
<div><p>What keys to itterate over in DataFrame.</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>fftDF</strong> : pd.DataFrame</p>
<blockquote class="last">
<div><p>Data Frame containing the absolute value of the fourier transformation of
the columns in dataFrame.</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</div>
<div class="section" id="module-d2o.analyze">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-d2o.analyze" title="Permalink to this headline">¶</a></h2>
</div>
</div>


           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'./',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="_static/jquery.js"></script>
      <script type="text/javascript" src="_static/underscore.js"></script>
      <script type="text/javascript" src="_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>